=== debian/changelog ===
box64 (0.3.2+dfsg-0.1~mx23+1) mx; urgency=medium

  * New upstream version 0.3.2+dfsg
  * Drop spelling.patch, applied upstream

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 30 Jan 2025 07:46:12 -0800
