=== debian/changelog ===
box64 (0.3.4+dfsg-1) unstable; urgency=medium

  [ Johannes Schauer Marin Rodrigues ]
  * debian/control: add Vcs-* headers.
    Thanks to Otto Kekäläinen <otto@debian.org>
  * debian/copyright: exclude new binaries
  * drop patches
  * debian/rules: build box32

  [ Otto Kekäläinen ]
  * Update git repository layout to follow DEP14 and DEP18

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Thu, 24 Apr 2025 11:54:47 +0200
