=== debian/changelog ===
box64 (0.3.6-0deepin1) unstable; urgency=medium

  * Update to upstream version 0.3.6

 -- April Lu <apr3vau@outlook.com>  Wed, 23 Jul 2025 11:08:00 +0800
