=== debian/watch ===
version=4
# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%box64-$1.tar.gz%" \
   https://github.com/ptitSeb/box64/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
